local hm_scoreboard = CV_RegisterVar({
	name = "hm_scoreboard",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hm_scoreboard_humor = CV_RegisterVar({
	name = "hm_scoreboard_humor",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hm_scoreboard_verbosestats = CV_RegisterVar({
	name = "showallstats",
	defaultvalue = "Off",
	flags = 0,
	possiblevalue = CV_OnOff
})

local KMPvars = {
	{disp = "Frantic Items", var = "kartfrantic"},
	{disp = "Bumpspark", var = "kmp_bumpspark"},
	{disp = "Hardsneaker", var = "kmp_hardsneakers"},
	{disp = "Long Flashtics", var = "kmp_extendflashtics"},
	{disp = "1.0.4 Spinout", var = "kmp_slowspinout"},
	{disp = "Dropped Item Fuse", var = "kmp_floatingitemfuse"},
	{disp = "Item Limiter", var = "kmp_itemlimiter"},
	{disp = "Orbital Limiter", var = "kmp_orbitlimit"},
	{disp = "Extended Hyudoro", var = "kmp_hyudoro"},
	{disp = "Orbinaut Fuse", var = "kmp_orbinautfuse"},
	{disp = "No Midair Squish", var = "kmp_growthbump"},
	{disp = "Haste", var = "kmp_haste"},
	{disp = "Respawn Anywhere", var = "kmp_respawnpoints"},
	{disp = "Shrink Cleanse", var = "kmp_shrinkcleanse"},
	{disp = "Shrink Pity", var = "kmp_shrinkduration"},
	{disp = "Battle Accel", var = "kmp_battleaccel"},
}

local diduno = {
	{msg = "You can turn off HORNMOD sounds by typing \135hornsoff\128 in your console.", cvar = "hornenabled"},
	{msg = "Hands getting sore? You can enable auto-accelerate with \135autoaccel\128 in your console.", cvartrue = "hm_autoaccel"},
	{msg = "HOSTMOD is the work of a laboratory gorilla with too much free time.", humor = true},
	{msg = "Try typing \135vote\128 in the console to see a list of votable commands."},
	{msg = "You should watch Symphogear!", humor = true},
	{msg = "This HOSTMOD update was brought to you by a Google Fiber outage.", humor = true},
	{msg = "Oranges are a great source of vitamin C. Bananas are a great source of anger.", humor = true},
	{msg = "Pac-Man was originally called 'Doki Doki Panic.' They changed his name because Nintendo were afraid people were going to turn 360 degrees and walk away.", humor = true},
	{msg = "Check out this massive plant.", humor = true},
	{msg = "If you main Pet Shop, you are a bad person.", humor = true},
	{msg = "Chengi asked me to put an iDOLM@STER tip here, but I don't know what the difference between it and Love Live is, and refuse to learn because it's funnier this way.", humor = true},
	{msg = "Me? Gongaga.", humor = true},
	{msg = "How is do be good for the image and see themselves well?", humor = true},
	{msg = "Have you ever made a map?", humor = true},
	{msg = "Stop asking if the Master Server is down.", humor = true},
	{msg = "In Super Smash Bros. Melee, the last 2 results of Mr. Game & Watch's judgment are stored internally and cannot be rolled again. This means that your chance of rolling a 9 will be a 1/7 unless it has been rolled within the past 2 uses of Judgment.", humor = true},
	{msg = "In Pokemon Red & Blue, due to a bug, using Focus Energy will quarter your chances of a critical hit instead of increasing it.", humor = true},
	{msg = "Did I leave my oven running when I went out for errands?", humor = true},
	{msg = "Reply hazy, ask again later.", humor = true},
	{msg = "Only you can decide if pineapple belongs on your pizza.", humor = true},
	{msg = "In Marvel vs. Capcom 2, the character Ruby Heart can perform a glitch to crash an arcade machine running the game. Don't try this at home!", humor = true},
	{msg = "V2 is coming out next Thursday. Shh, don't tell anyone!", humor = true},
	{msg = "You have higher acceleration while boosting; release your drift to make the most of it."},
	{msg = "Dragging items will slow you down, but orbiting items can be held with no penalty."},
	{msg = "Held and dragged items can't be stolen by Hyudoro."},
	{msg = "For a perfect startboost, press Accelerate right as the countdown hits 1. You'll even ignore offroad!"},
	{msg = "Hold Accelerate while respawning to Drop Dash."},
	{msg = "To pull an item as early as possible, hold the Item button while the roulette is spinning. Just remember, mashed items have worse odds!"},
	{msg = "Lobbed items are affected by your momentum. Fire on a downward slope or jump descent, and you'll get a brutal straight-ahead shot!"},
	{msg = "Lobbed items are affected by your momentum. If you fire on an upward slope, you might just end up hitting yourself!"},
	{msg = "Activating a Thunder Shield destroys all nearby hazards, including Badniks and fake item boxes."},
	{msg = "Thunder Shields aren't perfect protection; if you don't activate it in time, you can still be hit by hazards."},
	{msg = "Sapphire Coast's northwest area contains wasp badniks; keep your distance to avoid being spun out."},
	{msg = "Items placed on downward slopes can become brutal traps. Be wary."},
	{msg = "Item sets are chaotic areas, but they're powerful opportunities for an aggressive player. Go for a hit while their roulette is still spinning!"},
	{msg = "Jawz are persistent, but turn slowly. If you don't have an item, you can steer one into a wall to shake it."},
	{msg = "Hyudoro can be used to safely take certain shortcuts, but timing and patience can let you steal a powerful item. Try to go for both."},
	{msg = "Lobbed items will instantly hit players directly in front of you. Teach your opponents to respect your space!"},
	{msg = "When players are about to explode from a fake item box, they'll flash red. Keep your distance!"},
	{msg = "If you screwed up and picked up a fake item box, press the Item button again to explode early. You might be able to take someone with you..."},
	{msg = "You can type \135respawn\128 in the console if you're stuck in a wall or outside the track. Make sure to let the mapper know, so they can fix it."},
	{msg = "If you drift over a gap or jump, hold the Drift button while midair; you'll keep your miniturbo charge, and continue drifting when you land."},
	{msg = "Grow can stack with Invincibility, if you can set it up...and if you can control it once it's going."},
	{msg = "Can't get a clear shot on 1st place? Take note of their racing line, and place traps in their path for next lap."},
	{msg = "Eggboxes are easy to see when placed in the open. Hide them inside item sets for maximum effectiveness; just don't forget where you placed them."},
	{msg = "When holding multiple bananas, throwing or setting them resets your drag timer. Space your placement evenly to keep your speed."},
	{msg = "Touching the SPB will spin you out, even if you're not its target. Frontrunning players can use this for an extra layer of defense."},
	{msg = "Try shooting at players just after they pass through an item set; if they use their item to block yours, they'll be vulnerable as you pick up your next item."},
	{msg = "To \130sliptide\128, drift, turn in the same direction, and boost. Release Drift while maintaining your turn, and your turning radius will shrink."},
	{msg = "You're using tilt controls!", humor = true},
	{msg = "The SPB is twice as lethal in Combi Ring. If you pick up a Thunder Shield, hold onto it at all costs!", cvartrue = "combi_active"},
	{msg = "Invincibility and Grow can save your partner from an eggbox.", cvartrue = "combi_active"},
	{msg = "When targeted by the SPB, take wide lines and stick behind your partner. They'll pull you further away from danger.", cvartrue = "combi_active"},
	{msg = "Don't tug on the tether! Be mindful of your line, or both you and your partner will lose speed.", cvartrue = "combi_active"},
	{msg = "If your partner's spinning out, hold off on using sneakers or dash panels; they won't stop spinning until they slow down!", cvartrue = "combi_active"},
	{msg = "Combine your Grow with a partner's Invincibility or Rocket Sneakers for terrifying high-speed combebacks.", cvartrue = "combi_active"},
	{msg = "Springs and ramps can cause chaos for tethered players; if you're in front, try to take jumps at the same time as your partner.", cvartrue = "combi_active"},
	{msg = "\130USE YOUR TURN SIGNALS. \128It's free! (Custom 1 = Left, Custom 2 = Right, Custom 3 = Center)", cvartrue = "combi_active"},
	{msg = "Threading the needle with two people is way, way harder than doing it alone. Sometimes, safer paths are faster.", cvartrue = "combi_active"},
	{msg = "If you hold Accel + Brake after finishing a race, you can spin in circles. ...No, it's not actually useful, but it looks cute."},
	{msg = "Some maps differ between Record Attack and multiplayer; before taking a shortcut, make sure it's actually there!"},
	{msg = "If you're far behind, using Invincibility just before a new item set can set up a high-speed Invinc + Grow combo. Just be wary of Hyudoro!"},
	{msg = "Hmm...today, I will take the Egg Quarters turn 1 cut. (clueless)", humor = true},
	{msg = "If you make a Midnight Channel piss joke, Lat will show up at your house with a baseball bat and a briefcase of yuri manga.", humor = true},
	{msg = "If you're in 2nd place with an SPB, use it before 1st finishes, or it'll instantly turn on you. Whoops."},
	{msg = "Don't mash Rocket Sneakers! If you wait to boost until your last boost has finished, they'll last a lot longer."},
	{msg = "Use Custom 3 to signal your Ultimate. When everyone's ready, use Custom 2 to activate it; synchronized Ultimates last way longer.", cvar = "tsr_forceteamcolors"},
	--KRU Messages
	{msg = "Fuck Karts R Us", humor = true},
	{msg = "Throwing an Eggbomb in front of you and deliberately driving into it can be a strategy if you're confident that you'll pass it to another driver."},
	{msg = "Rule 1 of KRU: No fun allowed", humor = true},
	{msg = "Rule 2 of KRU: Curb Your Jokes...", humor = true},
	{msg = "The green fluid in this room looks like something you probably don't wanna touch!", humor = true},
	{msg = "Don't forget to wish rhophasofa a happy birthday!", humor = true},
	{msg = "If you shoot an orbi ahead of you and it doesn't hit anything/fall into a pit, that same orbi is 33% more likely to return and hit you.", humor = true},
	{msg = "Press the tilde key (the one below escape that looks like this ~) to access the console."},
	{msg = "In Boingmode, characters with high acceleration gets a higher speed increase from tricks, and vice versa. If you can't handle the speed, you can use fast characters... to go slower?"},
	{msg = "It's ok to be peeved at the game. It's not ok to take out your anger on other players."},
	{msg = "IDC is always on for votes. So you better vote if you do or don't want a vote to pass!"},
	{msg = "I've been stuck here telling people tips about this game for 3 years. Please get me out of here...", humor = true},
	{msg = "Blows up!?", humor =  true},
	{msg = "Kart has a big learning curve, so if you are getting stomped, don't worry! It happens to all new players, just continue learning from others and try to improve and you'll start to do much better."},
	{msg = "Type `quit losing` in console to immediately close your client", humor = true},
	{msg = "Is your refridgerator running? Well you BETTER GO CATCH IT! OOOOOOOOOOOOOOOOOOH!", humor = true},
	{msg = "Press `Tab` to see the Did You Know Section.", humor = true},
	{msg = "KRU says trans rights!"},
	{msg = "The US version of Super Mario Bros. 2 is not the same as the Japanese version of Super Mario Bros. 2? The US version is actually based on a Japan-only game called Doki Doki Literature Club. Isn't that crazy?", humor = true},
	{msg = "Karts R Us and The R Zone use the exact same addon list, so you can switch between them without having to quit your game!"},
	{msg = "Sonic has been super-glued to his kart so he doesn't cheat.", humor = true},
	{msg = "So, you threw your mine forward and bombed yourself.", humor = true},
	{msg = "Remember, you're doing this for the chao audience. Do NOT disappoint them!", humor = true},
	{msg = "If one player is lagging behind a bit in Combi-mode, they can slipstream off their partner to help them keep up. Teamwork is key!", cvartrue = "combi_active"},
	{msg = "You don't have enough memory in the memory card!", humor = true},
	{msg = "If your combi teammate accidentally grabs an eggbox, bump in to them! You can ping pong back and forth to keep it from ever exploding!", cvartrue = "combi_active"},
	{msg = "What is a Kart? A miserable little pile of mods!", humor = true},
	{msg = "SRB2K's download size is 200 Mb. By joining this server, that file size tripled.", humor = true},
	{msg = "This server has acrobasics, so press brake to perform a trick to get a chainable speedboost."},
	{msg = "Sometime, the most aggressive item plays aren't always effective in podium positions. Be sure keep an item on you to defend yourself with when the time comes."},
	{msg = "This wall tastes like dirt!", humor = true},
	{msg = "Don't forget, you're here forever.", humor = true},
	{msg = "Your free trial for Sonic Robo Blast 2 Kart has ended; to continue playing, insert cash, or select payment type.", humor = true},
	{msg = "Unexpected item in bagging area.", humor = true},
	{msg = "If you're going to make a playful jab at someone, you need to make it clear that you're joking. Otherwise you come off as toxic."},
	{msg = "We've been trying to reach you about your car's extended warranty.", humor = true},
	{msg = "Whoever is the owner of a white sedan, you left your lights on.", humor = true},
	{msg = "You are not a clown. You are the entire circus.", humor = true},
	{msg = "Now this is a story of all about how my life got flipped turned upside-down, now I'd like to take a minute, just sit right there! I'll tell you how I became a prince of a town called Bel-Air!", humor = true},
	{msg = "Ngl we should probably archive this channel lmao, the last diduno that got accepted was 2 months ago.", humor = true},
	{msg = "I summon Pot of Greed to draw 3 additional cards from my deck, and then I summon Pot of Greed to draw 3 additional cards to my deck!", humor = true},
	{msg = "You get nothing! You lose! Good DAY sir!", humor = true},
	{msg = "Have a horn you want added? Join the discord and ping Bladesinger repeatedly to open the horn suggestion channel. (pls dont actually -Blade)", humor = true},
	{msg = "Well I'm leaving the server it's rude and pretty much no understand or respect bad server.", humor = true},
	{msg = "\133THE \133FOG \133IS \133COMING \133THE \133FOG \133IS \133COMING \133THE \133FOG \133IS \133COMING", humor = true},
	{msg = "Please do not do acrobatics in the Jelly room, thanks.", humor = true},
	{msg = "If you're reading this, pretend you're a bar of soap so you can give your opponents the slip.", humor = true},
	{msg = "humor = true", humor = true},
	{msg = "Would you rather have unlimited bacon but no more video games, or games, unlimited games, but no games", humor = true},
	{msg = "If you do drugs, you go to hell before you die.", humor = true},
	{msg = "The soup is cold and the salad is hot", humor = true},
	{msg = "Look behind you.", humor = true},
	{msg = "I'M BACK IN THE FUCKING BUILDING AGAIN", humor = true},
	{msg = "The Checker Wrecker can be used to roll over racers and items directly. It also interacts with slopes and objects that players do, so watch out."},
	{msg = "Honk your horn at the start of the race for good luck!", humor = true},
	{msg = "Everyone, lend me your energy!", humor = true},
	{msg = "Did you know that, the Did You Know scoreboard lets you know of something that you probably hadn't known before to let you know about cool things you probably actually know?", humor = true},
	{msg = "Add Rain to World.", humor = true},
	{msg = "Live life like you have an SPB chasing after you.", humor = true},
	{msg = "I missed you!", humor = true},
	{msg = "Typing 'banana' on the title screen unlocks everything!"},
	{msg = "Typing 'quit smoking' in console unlocks everything!", humor = true}
}

rawset(_G, "HM_Scoreboard_AddTip", function(fug)
	table.insert(diduno, fug)
end)

rawset(_G, "HM_Scoreboard_AddMod", function(fug)
	table.insert(server.HMNSBbalance, fug)
end)

local function clan(p, ...)
	if not hm_scoreboard.value then
		CONS_Printf(p, "This function has been disabled by the server host.")
		return
	end
	if not ... then
		p.HMclan = nil
		CONS_Printf(p, "Clan tag removed.")
	else
		local fug = table.concat({...}, " ")
		local lowerfug = fug:lower()
		if fug:len() > 10 then
			CONS_Printf(p, "Too long.")
			return
		elseif lowerfug:match("staff") or lowerfug:match("admin") or lowerfug:match("krew") or lowerfug:match("mod") or lowerfug:match("~") or lowerfug:match("@") then
			CONS_Printf(p, "Nice Try!")
			return
		else
			p.HMclan = fug
			if lowerfug:match("gang") then
				CONS_Printf(p, 'Tag set to "'..fug..'". :V')
			else
				CONS_Printf(p, 'Tag set to "'..fug..'".')	
			end
		end
	end
end
COM_AddCommand("clan", clan)

local wrapped = {}

-- I KNOW THERE'S A FUCKIN FUNCTION IN SOURCE FOR THIS
-- WHY IS IT NOT EXPOSED TO LUA
-- LAAAAAAAAAAAAAAAAAAAAAAT
local function wrapString(str, width, v, flags, font)
	local words = {}
	for word in str:gmatch("%S+") do table.insert(words, word) end
	local retlines = {}
	local buffer = words[1]
	for i = 2, #words
		local fug = buffer.." "..words[i]
		if v.stringWidth(fug, flags, font) > width then
			table.insert(retlines, buffer)
			buffer = words[i]
		else
			buffer = fug
		end
	end
	table.insert(retlines, buffer)
	return retlines
end

local function doEscapeCode(str)
	for _, v in pairs(hm_escape)
		str = str:gsub(v.a, v.b)
	end
	return str
end

local function buildTimeString(x)
	if x == nil or x == 99999999 then return "N/A" end
	return ""..string.format("%02d", G_TicsToMinutes(x)).."' "..string.format("%02d", G_TicsToSeconds(x))..'" '..string.format("%02d", G_TicsToCentiseconds(x))
end

addHook("ThinkFrame", function()
	server.HMNSBmsg = $ or {}
	if server.HMNSBbalance == nil then
		server.HMNSBbalance = {}
		for _, v in ipairs(KMPvars)
			table.insert(server.HMNSBbalance, v)
		end
	end
	if leveltime == 1 then
		wrapped = {}
		local fug = true
		local result = nil
		while fug
			fug = false
			local target = diduno[P_RandomRange(1, #diduno)]
			server.HMNSBtip = target.msg
			if target.cvar and not CV_FindVar(target.cvar) then
				hm_dprint("Didn't find cvar", target.cvar, "so we're fucking off")
				fug = true
			end
			if target.cvartrue then
				if CV_FindVar(target.cvartrue) then
					if not CV_FindVar(target.cvartrue).value then
						hm_dprint("Found cvar", target.cvartrue, "and it was false, bye")
						fug = true
					end
				else
					hm_dprint("Didn't find cvar", target.cvartrue, "so we're fucking off")
					fug = true
				end
			end
			if target.humor and not hm_scoreboard_humor.value then
				hm_dprint("host hates fun")
				fug = true
			end
		end
		hm_dprint("found", server.HMNSBtip)
	end
end)

-- Stuff from SFG, related to the displayed skin in scoreboard upon a forced spec
addHook("ThinkFrame", function()
	if leveltime == 0 then return end

	-- "Do not alter player_t in HUD rendering code!" :nerd:
	for p in players.iterate do
		local oldspec = p.spectator
		p.spectator = false
		-- start simple, just scoreboard for now...
		p.hostmod_skin = p.mo.skin
		p.hostmod_color = p.mo.color
		p.hostmod_colorized = p.mo.colorized
		// saturn only!
		p.hostmod_localskin = p.mo.localskin
		p.spectator = oldspec
	end
end)

local function addscoreboardline(p, ...)
	if not ... then
		CONS_Printf(p, "Usage: hm_scoreboard_addline <text>")
	end
	table.insert(server.HMNSBmsg, doEscapeCode(table.concat({...}, " ")))
end
COM_AddCommand("hm_scoreboard_addline", addscoreboardline, 1)

local function hm_scoreboard_addmod(p, ...)
	if not ... then
		CONS_Printf(p, "Usage: hm_scoreboard_addmod <text>")
	end
	table.insert(server.HMNSBbalance, { disp = doEscapeCode(table.concat({...}, " "))})
end
COM_AddCommand("hm_scoreboard_addmod", hm_scoreboard_addmod, 1)

-- hacked-up TSR scoreboard, WHEEEEEEEEEEEEEEE
-- thanks snu
hud.add(function(v, p, c)
	if not hm_scoreboard.value then
		hud.enable("rankings")
		return
	end
	hud.disable("rankings")
	v.fadeScreen(0xFF00, 16)	-- fade the screen

	-- store highlight colour here for use in the hud throughout
	local hilicol
	if (CV_FindVar("menuhighlight").value)
		hilicol = CV_FindVar("menuhighlight").value
	elseif (modeattacking)
		hilicol = V_ORANGEMAP
	else
		hilicol = ((gametype == GT_RACE) and V_SKYMAP or V_REDMAP)
	end
	
	if false and consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
		local reverseplayers = {}
		for k,v in players.iterate do
		   reverseplayers[v] = k
		end
	end
	
	-- draw lap count and game speed
	if not G_BattleGametype() then
		v.drawString(64, 8, "LAP COUNT", 0, "center")
		v.drawString(64, 16, (numlaps), hilicol, "center")
		v.drawString(256, 8, "GAME SPEED", 0, "center")
		v.drawString(256, 16, CV_FindVar("kartspeed").string, hilicol, "center")
	end
	
	-- draw line between gametypeinfo and teams
	local dupadjust = (v.width()/v.dupx())
	local duptweak = (dupadjust - 320)/2	-- BASEDVIDWIDTH = 320 (based on what?)
	v.drawFill(1-duptweak, 26, dupadjust-2, 1, 0)	-- horizontal
	v.drawFill(160, 26, 1, 162, 0)	-- vertical
	
	v.drawString(4, 188, hm_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl).." - "..mapheaderinfo[gamemap].subttl, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")

	-- draw right pane
	local fy = 28
	local fx = 163
	local off = 0 -- right pane line offset OH GOD this code is everywhere
	local motd = CV_FindVar("hm_motd")
	if motd and motd.value then
		v.drawString(fx, fy, doEscapeCode(CV_FindVar("hm_motd_name").string), V_ALLOWLOWERCASE, "thin")
		v.drawString(fx, fy+10, "\134Contact: "..doEscapeCode(CV_FindVar("hm_motd_contact").string), V_ALLOWLOWERCASE, "small")
		off = $ + 4
	end
	
	local restat = CV_FindVar("hm_restat")
	
	if server.HMNSBmsg then
		for key, val in ipairs(server.HMNSBmsg)
			v.drawString(fx, fy+(off*5), val, V_ALLOWLOWERCASE, "small")
			off = $ + 1
		end
		off = $ + 1
	end
	
	local drew = false
	local dupes = {}

	for key, val in ipairs(server.HMNSBbalance)
		local drawthatshit = false
		if not val.var then
			drawthatshit = true
		elseif CV_FindVar(val.var) then
			if CV_FindVar(val.var).value then drawthatshit = true end
		end
		if drawthatshit and (not dupes[val]) then
			if not drew then
				v.drawString(fx, fy+(5*off), "\134Gameplay / Balance Changes:", V_ALLOWLOWERCASE, "thin")
				off = $ * 2 + 4
			end
			drew = true
			if off % 2 then
				v.drawString(fx+77, fy+(off/2*5), val.disp, V_ALLOWLOWERCASE, "small")
			else
				v.drawString(fx, fy+(off/2*5), val.disp, V_ALLOWLOWERCASE, "small")
			end
			off = $ + 1
			dupes[val] = true
		end
	end
	
	if drew then off = ($ / 2) + ($ % 2) + 1 end
	
	if server.HMNSBtip then
		v.drawString(fx, fy+(off*5), "\134Did You Know?", V_ALLOWLOWERCASE, "thin")
		off = $ + 2
		if #wrapped < 1 then
			hm_dprint("regenerating wrapped tip")
			wrapped = wrapString(server.HMNSBtip, 150, v, V_ALLOWLOWERCASE, "small")
		end
		for _, val in ipairs(wrapped)
			v.drawString(fx, fy+(off*5), val, V_ALLOWLOWERCASE, "small")
			off = $ + 1
		end
		off = $ + 1
	end

	-- draw players
	local tsr_rankings = {}
	for p in players.iterate
		if (p and p.valid) and not p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	table.sort(tsr_rankings, function(a, b) return a.kartstuff[k_position] < b.kartstuff[k_position] end)
	for p in players.iterate
		if p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	if not #tsr_rankings then return end

	for i = 1, #tsr_rankings
		local p = tsr_rankings[i]
		local hy = 28 + (i-1)*10
		local specflag = (p.spectator or p.rs_check2) and V_50TRANS or 0

		-- player ping:
		if (p ~= server)  -- the server doesnt have a ping
		and (netgame)	-- we obviously need to be in a netgame too
			-- my hopes with writing this code is that it's so bad that I'm never allowed to write ping related code ever again
			local ping = p.ping
			-- get the ping patch we'll use
			local ping_gfxnum, ping_values = 1, {2, 4, 7, 10}
			for i = 1, #ping_values
				if (ping >= ping_values[i]) then ping_gfxnum = i+1 end
			end
			-- sadly p.cmd.latency caps at 11 so it cant go any higher without hacks so huge that I cant be assed
			v.draw(3, hy, v.cachePatch("HMPING"..ping_gfxnum), specflag)
		end
		-- rank:
		if not p.spectator then
			v.drawString(29, hy+1, p.kartstuff[k_position], 0, "right")
		end
		-- draw skin icon
		local pp = skins[p.hostmod_skin].facerank
		if p.hostmod_localskin and skins[p.hostmod_localskin] then
			pp = skins[p.hostmod_localskin].facerank
		end
		local cmap = v.getColormap(p.hostmod_skin, p.hostmod_color)
		local dieflag = 0
		if p.hostmod_colorized then cmap = v.getColormap(TC_RAINBOW, p.hostmod_color) end
		if G_BattleGametype() and p.kartstuff[k_bumper] <= 0 then
			cmap = v.getColormap(TC_RAINBOW, SKINCOLOR_GREY)
			dieflag = V_50TRANS
		end
		v.drawScaled(30<<FRACBITS, (hy+1)<<FRACBITS, FRACUNIT/2, v.cachePatch(pp), specflag|dieflag, cmap)
		-- name: c[p.tsr_team]..p.name
		local c = 0
		local index = p.tsr_team or 6
		local fugname = ""
		if p.HMclan then fugname = $.."\140"..p.HMclan.." \128" end
		--if p.HMclan then fugname = $..hm_color[p.skincolor]..p.HMclan.." | \128" end
		if p == consoleplayer then fugname = $..hm_color[p.skincolor] end
		if p.name == nil then
			fugname = $.."Glitched player :?"
		else
			fugname = $..p.name
		end
		while v.stringWidth(fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin") > 100
			fugname = $:sub(1, -2)
		end
		if consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
			fugname = $.." \x86["..#p.."]"
		end
		v.drawString(39, hy, fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin")
		if (p.mo and p.mo.valid) then
			if (restat.value and p.HMRs) or hm_scoreboard_verbosestats.value then
				local restatflag = (hm_scoreboard_verbosestats.value and p.HMRs) and V_YELLOWMAP or 0
				v.drawString(29, hy, p.kartspeed, restatflag, "small")
				v.drawString(39, hy+6, p.kartweight, restatflag, "small-right")
			end
		end
		-- points:
		local points = ""
		if p.spectator then
			if p.pflags & PF_WANTSTOJOIN then
				points = "WAIT"
			elseif Elimination and p.elim_rejoinEnd then
				points = "ELIMINATED"
			else
				points = "SPEC"
			end
		elseif p.rs_check2 then
			points = "RAGE"
		elseif p.pflags & PF_TIMEOVER then
			points = "NO CONTEST."
		elseif G_BattleGametype() then
			points = p.marescore
		elseif not p.exiting then
			points = "LAP "..(p.laps+1)
		else
			points = buildTimeString(p.realtime)
		end
		v.drawString(157, hy, points, (p.exiting and hilicol or 0)|V_6WIDTHSPACE|specflag, "thin-right")
	end
end, "scores")